<?xml version="1.0" encoding="UTF-8"?>
<!--
 #=============================================================================#
 # Copyright (c) 2018, 2025 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================#
-->

<ecore:EPackage xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:ecore="https://www.eclipse.org/emf/2002/Ecore" name="ggplot" nsURI="http://walware.de/rtm/Rt-ggplot/1.0" nsPrefix="ggplot">
  <eClassifiers xsi:type="ecore:EClass" name="GGPlot" eSuperTypes="#//PropDataProvider #//PropXVarProvider #//PropYVarProvider">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="dataFilter" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RDataFilter"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="mainTitle" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RLabel"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="mainTitleStyle" lowerBound="1"
        eType="#//TextStyle" containment="true"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="facet" eType="#//FacetLayout"
        containment="true"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="axXLim" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNumRange"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="axYLim" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNumRange"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="axXLabel" ordered="false"
        eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RLabel"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="axYLabel" ordered="false"
        eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RLabel"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="axXLabelStyle" lowerBound="1"
        eType="#//TextStyle" containment="true"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="axYLabelStyle" lowerBound="1"
        eType="#//TextStyle" containment="true"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="axXTextStyle" lowerBound="1"
        eType="#//TextStyle" containment="true"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="axYTextStyle" lowerBound="1"
        eType="#//TextStyle" containment="true"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="layers" upperBound="-1"
        eType="#//Layer" containment="true"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="Layer" abstract="true" eSuperTypes="#//PropDataProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="XVarLayer" abstract="true" eSuperTypes="#//Layer #//PropXVarProvider #//PropGroupVarProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="XYVarLayer" abstract="true" eSuperTypes="#//Layer #//PropXVarProvider #//PropYVarProvider #//PropGroupVarProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="GeomAblineLayer" eSuperTypes="#//Layer #//PropLineTypeProvider #//PropSizeProvider #//PropColorProvider #//PropAlphaProvider">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="interceptVar" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNum"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="slopeVar" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNum"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="GeomBarLayer" eSuperTypes="#//XYVarLayer #//PropStatProvider #//PropColorProvider #//PropFillProvider #//PropAlphaProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="GeomBoxplotLayer" eSuperTypes="#//XVarLayer #//PropColorProvider #//PropFillProvider #//PropAlphaProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="GeomHistogramLayer" eSuperTypes="#//XVarLayer #//PropColorProvider #//PropFillProvider #//PropAlphaProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="GeomLineLayer" eSuperTypes="#//XYVarLayer #//PropStatProvider #//PropLineTypeProvider #//PropSizeProvider #//PropColorProvider #//PropAlphaProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="GeomPointLayer" eSuperTypes="#//XYVarLayer #//PropShapeProvider #//PropSizeProvider #//PropColorProvider #//PropFillProvider #//PropAlphaProvider">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="positionXJitter" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNum"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="positionYJitter" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNum"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="GeomTextLayer" eSuperTypes="#//XYVarLayer #//TextStyle #//PropAlphaProvider">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="label" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RVar"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="GeomSmoothLayer" eSuperTypes="#//XYVarLayer #//PropSizeProvider #//PropColorProvider #//PropFillProvider #//PropAlphaProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="GeomTileLayer" eSuperTypes="#//XYVarLayer #//PropLineTypeProvider #//PropColorProvider #//PropFillProvider #//PropAlphaProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="GeomViolinLayer" eSuperTypes="#//XYVarLayer #//PropLineTypeProvider #//PropColorProvider #//PropFillProvider #//PropAlphaProvider"/>
  <eClassifiers xsi:type="ecore:EClass" name="FacetLayout" abstract="true" interface="true"/>
  <eClassifiers xsi:type="ecore:EClass" name="GridFacetLayout" eSuperTypes="#//FacetLayout">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="colVars" upperBound="-1"
        eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RVar"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="rowVars" upperBound="-1"
        eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RVar"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="WrapFacetLayout" eSuperTypes="#//FacetLayout">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="colVars" upperBound="-1"
        eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RVar"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="colNum" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RInt"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="Stat" abstract="true"/>
  <eClassifiers xsi:type="ecore:EClass" name="IdentityStat" eSuperTypes="#//Stat"/>
  <eClassifiers xsi:type="ecore:EClass" name="SummaryStat" eSuperTypes="#//Stat">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="yFun" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RFunction"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="TextStyle" eSuperTypes="#//PropSizeProvider #//PropColorProvider">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="fontFamily" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RFontFamily"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="fontFace" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RText"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="hJust" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNum"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="vJust" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNum"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="angle" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RNum"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropDataProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="data" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RDataFrame"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropXVarProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="xVar" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RVar"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropYVarProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="yVar" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RVar"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropStatProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EReference" name="stat" eType="#//Stat" containment="true"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropGroupVarProvider" abstract="true"
      interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="groupVar" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RVar"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropShapeProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="shape" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RPlotPointSymbol"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropLineTypeProvider" abstract="true"
      interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="lineType" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RPlotLineType"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropSizeProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="size" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RSize"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropColorProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="color" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RColor"
        defaultValueLiteral=""/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropFillProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="fill" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RColor"
        defaultValueLiteral=""/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="PropAlphaProvider" abstract="true" interface="true">
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="alpha" eType="ecore:EDataType platform:/plugin/org.eclipse.statet.rtm.base.core/model/RtData-1.ecore#//RAlpha"
        defaultValueLiteral=""/>
  </eClassifiers>
</ecore:EPackage>
